#
# Pu-roxy ư
#
# (c) FukTommy <fuktommy@inter7.jp>
#
# Released under the GNU General Public License
#

package Pu::System;
use Pu::Config;

$AGENT = "Monazilla/1.00 (Pu-roxy/0.1.7)";

#----------------------------------------------------------------------#
# եΥ(ʬΤ)
# : URL
# : ɤ
sub sync($) {
	my($url) = @_;
	checkMove($url);
	my $file = $url;
	$file =~ s|http://||;
	$file =~ s|~|%7E|g;
	$file = $Pu::Config::cacheDir . "/" .  $file;
	return update($url) unless (-e $file);
	my $code = system $Pu::Config::wget,
		"-q", "-U", $AGENT, "-c", "-x",
		"-Y", "off",
		"-T", $Pu::Config::timeout, "-t", "1",
		"-P", $Pu::Config::cacheDir, $url;
	return !$code;
}

#----------------------------------------------------------------------#
# եΥ()
# : URL
# : ɤ
sub get($) {
	my($url) = @_;
	checkMove($url);
	my $code = system $Pu::Config::wget,
		"-q", "-U", $AGENT, "-x",
		"-T", $Pu::Config::timeout, "-t", "1",
		"-Y", "off", "-N",
		"--header=Accept-Encoding: gzip",
		"-P", $Pu::Config::cacheDir, $url;
	gunzip($url) if ($code == 0);
	return !$code;
}

#----------------------------------------------------------------------#
# եΥ()
# : URL
# : ɤ
sub update($) {
	my($url) = @_;
	checkMove($url);
	my $code = system $Pu::Config::wget,
		"-q", "-U", $AGENT, "-x",
		"-T", $Pu::Config::timeout, "-t", "1",
		"-Y", "off",
		"--header=Accept-Encoding: gzip",
		"-P", $Pu::Config::cacheDir, $url;
	gunzip($url) if ($code == 0);
	return !$code;
}

#----------------------------------------------------------------------#
# åɤǽ(˥塼)
# : URL
sub printMenu($) {
	my($url) = @_;
	$url =~ s|http://||;
	$url =~ s|~|%7E|g;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	Pu::Document::printHeader("2ch menu");
	print "<BODY><UL>\n",
	      "<LI><A href='$main::pu?mode=cache'>Cache</A>\n",
	      "<LI><A href='$main::pu?mode=tcache'>Cache(sort by timestamp)</A>\n";
	local $_;
	my $stat_comment = 0;
	open IN, $file;
	my @buf = <IN>;
	close IN;
	while (@buf) {
		$_ = shift @buf;
		if (/<!--/ && (! /-->/)) {
			$stat_comment = 1;
		} elsif ($stat_comment && /-->/) {
			$stat_comment = 0;
		} elsif ($stat_comment) {
			next;
		} elsif (m|^<A HREF=http://[^.]*\.2ch\.net/|i ||
		    m|^<A HREF=http://[^.]*\.bbspink\.com/|i) {
			s|HREF=http://|href="$main::pu?url=|;
			s|<BR>||gi;
			s|>|">|;
			print "<LI>$_";
		} elsif (m|<B>(.*)</B>|i) {
			print "</UL><H3>$1</H3><UL>\n";
			unshift @buf, $';
		} elsif (m|^(<BR>)*<A HREF.*</A>|i) {
			s|<BR>||gi;
			s|HREF=|href="|;
			s| *TARGET=_blank||;
			s|>|">|;
			print "<LI>$_";
		}
	}
	print "</UL></BODY></HTML>";
}

#----------------------------------------------------------------------#
# åɤǽ()
# : URL
sub printSubject($) {
	my($url) = @_;
	$url =~ s|http://||;
	$url =~ s|~|%7E|g;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	my($bbsName, $base) = getBbsName($url);
	Pu::Document::printHeader($bbsName);
	print "<BODY><H1>$bbsName</H1><UL>\n";
	open IN, $file;
	while (<IN>) {
		chop;
		if (m|^(\d+)\.dat<>|) {
			my($num, $thread) = ($1, $');
			$thread =~ s/&/&amp;/g;
			$thread =~ s/([gl])t;/&$1t;/g;
			$thread =~ s/&amp;&([gl])t;/&$1t;/g;
			print "<LI><A href='$main::pu?url=${base}dat/$num.dat'>$thread</A>\n";
		} else {
			last;
		}
	}
	close IN;
	print "</UL></BODY></HTML>";
}

#----------------------------------------------------------------------#
# åɤǽ()
# : URL
sub printDat($) {
	my($url) = @_;
	$url =~ s|http://||;
	$url =~ s|~|%7E|g;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	my $title = searchTitle($url);
	if ($title ne "") {
		$title =~ s/&/&amp;/g;
		$title =~ s/([gl])t;/&$1t;/g;
		$title =~ s/&amp;&([gl])t;/&$1t;/g;
	}
	local $_;
	my $i=0;
	Pu::Document::printHeader($title);
	if ($title eq "") {
	        my $link = $url;
		$link =~ s|dat/\d+.dat||;
		$title = "<A href='$main::pu?url=$link'>$link</A>";
	}
	print "<BODY><H1>$title</H1><DL>\n";

	open IN, $file;
	while (<IN>) {
		$i++;
		local @_ = split /<>/;
		my($name, $mail, $date, $cont) = @_;
		$name = "<SPAN class='name'>$name</SPAN>";
		$name =~ s|<b>|<SPAN class='name'>|g;
		$name =~ s|</b>|</SPAN>|g;
		$name =~ s|<SPAN[^>]*> *</SPAN>||ig;
		$cont = plastic($cont);
		print "<DT id='r$i'>$i :$name",
		      " [$mail] $date<DD>$cont<BR><BR>\n";
	}
	close IN;
	if ($i == 0) {
		print "<DT>DAT? HTML?";
		my $kako = $url;
		$kako =~ s|(\w+)/dat|test/read.cgi/$1|;
		$kako =~ s|\.dat$|/l50|;
		print "<DD><A href='http://$kako'>http://$kako</A>";
	}
	print "</DL>\n";
	my $link = $url;
	$link =~ s|(\w+)/dat|test/read.cgi/$1|;
	$link =~ s|\.dat$|/l50|;
	print "<P>................ ",
	      "<A href='http://$link'>http://$link</A><BR>",
	      "................ ",
	      "<A href='$main::pu?mode=post&amp;url=$url'>Post</A>",
	      "................",
	      "<A href='$main::pu?mode=update&amp;url=$url'>Force-Update</A></P>",
	      "</BODY></HTML>\n";
}

#----------------------------------------------------------------------#
# Υȥ򸡺
# : URL
# : Υȥ
sub searchTitle($) {
	my($url) = @_;
	my $subject = $Pu::Config::cacheDir . "/" .  $url;
	$subject =~ /(\d+)\.dat/;
	my $name = $1;
	$subject =~ s|dat/\d+.dat|subject.txt|;

	# εϿ鸡
	local $_;
	my %hush = ();
	my $titleData = $Pu::Config::cacheDir . "/title.txt";
	open IN, $titleData;
	while (<IN>) {
		chop;
		local @_ = split /\s+|<>/, $_, 2;
		$hush{$_[0]} = $_[1];
	}
	close IN;
	return $hush{$url} if (defined $hush{$url});

	# subject.txt鸡
	%hush = ();
	open IN, $subject;
	while (<IN>) {
		if (m|^(\d+)\.dat<>(.+)\(\d+\)$|) {
			my $num = $1;
			my $title = $2;
			$hush{$num} = $title;
		}
	}
	close IN;

	if (defined $hush{$name}) {
		open OUT, ">> $titleData";
		print OUT "$url<>$hush{$name}\n";
		close OUT;
		return $hush{$name};
	} else {
		return "";
	}
}

#----------------------------------------------------------------------#
# 
# : ʸ
# : ʸ
sub plastic($) {
	my($cont) = @_;
	$cont =~ s/<a.*?>|<\/a>//ig;
	$cont =~ s/(&gt;&gt;|>>|\201\204|\201\164|\201\342|&gt;)(\d+)/<a href='#r$2'>$&<\/a>/g;
	$cont =~ s|https?://[\041-\073\075-\177]{2,}|<a href='$&'>$&<\/a>|g;
	$cont =~ s|([^h])(ttps?://[\041-\073\075-\177]{2,})|$1<a href='h$2'>$2<\/a>|g;
	$cont =~ s|<a href='(http://[^>]*?\.2ch\.net/[^>]*?)'[^>]*?>|<a href='$main::pu?url=$1'>|g;
	$cont =~ s|<a href='(http://[^>]*?\.bbspink\.com/[^>]*?)'[^>]*?>|<a href='$main::pu?url=$1'>|g;
	return $cont;
}

#----------------------------------------------------------------------#
# Ĥΰưб
# : URL
sub checkMove($) {
	my($url) = @_;
	$url =~ s|http://||;
	$url =~ s|~|%7E|g;
	my $dir = $Pu::Config::cacheDir;
	local @_ = split /\//, $url;
	my $host = $_[0];
	my $bbs  = $_[1];
	local $_;
	foreach (glob "$dir/*") {
		if ($_ eq "$dir/$host") {
			next;
		} elsif (-d "$_/$bbs") {
			mkdir "$dir/$host", 0777 unless (-d "$dir/$host");
			rename "$_/$bbs", "$dir/$host/$bbs";
			last;
		}
	}
}

#----------------------------------------------------------------------#
# å
# : ץ(sort=>file, sort=>stamp)
sub cache(;%) {
	my %opt = @_;
	my $file = $Pu::Config::cacheDir . "/title.txt";
	local $_;
	Pu::Document::printHeader("2ch cache");
	print "<BODY><H1>2ch cache</H1><UL>\n";
	my @line = ();
	open IN, $file;
	my @thread = ();
	while (<IN>) {
		chomp;
		local @_ = split /\s+|<>/, $_, 2;
		$_[1] =~ s/&/&amp;/g;
		$_[1] =~ s/([gl])t;/&$1t;/g;
		$_[1] =~ s/&amp;&([gl])t;/&$1t;/g;
		my @stat = stat($Pu::Config::cacheDir . "/" . $_[0]);
		my $t = { file  => $_[0],
			  name  => $_[1],
			  stamp => $stat[9],};
		push @thread, $t;
	}
	close IN;
	if ($opt{sort} eq "stamp") {
		@thread = sort {$$b{stamp} <=> $$a{stamp}} @thread;
	} else {
		@thread = sort {$$a{file} cmp $$b{file}} @thread;
	}
	foreach (@thread) {
		print "<LI><A href='$main::pu?url=$$_{file}'>$$_{name}</A>\n";
	}
	print "</UL></BODY></HTML>";
}

#----------------------------------------------------------------------#
# gunzip
# : URL
sub gunzip($) {
	my($url) = @_;
	$url =~ s|http://||;
	$url =~ s|~|%7E|g;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	rename $file, "$file.gz";
	system $Pu::Config::gzip, "-d", "-q", $file . ".gz";
	if (-e "$file.gz") {
		rename "$file.gz", $file;
	}
}

#----------------------------------------------------------------------#
# ĤΰĤ̾ʤɤ򸡺
# : URL
# : Ĥ̾, ĤURL
sub getBbsName($) {
	my($url) = @_;
	$url =~ s|//*subject.txt|/|;
	my $bbsName;
	my $menuURL = $Pu::Config::menuURL;
	$menuURL =~ s|http://||;
	$menuURL =~ s|~|%7E|g;
	open IN, $Pu::Config::cacheDir . "/" .  $menuURL;
	while (<IN>) {
		if (m|^<A HREF=http://$url>(.+)</A><br>|i) {
			$bbsName = $1;
		}
	}
	close IN;
	return ($bbsName, $url);
}

1;
